;******************************************************************
; COMTEL - Commande tlphonique
; Version 1.0	
; 
; RA	
; 0 17	A3 de ISD	
; 1 18	A4 de ISD
; 2 01	A5 de ISD
; 3 02	CE de ISD
; 4 03	Sonnerie
;
; RB
; 0 06	Relais ligne	
; 1 07	Entre Etat
; 2 08	Relais commande
; 3 09	DV de SSI 
; 4 10	D  de SSI
; 5 11	C  de SSI
; 6 12	B  de SSI
; 7 13	A  de SSI
;
;******************** ************************************************

	list p=16f84,f=inhx8m

        __config  B'00000000000001'    ; WDT Disabled, XT Oscillator
;
        #include "p16f84.inc"

;**** Variables
	cblock	0x0C
		n1, n2, n3, n4
		delay, xdelay, sdelay, zdelay
		count, flag, ret, var, compt, duree, resu, essai
		w_tmp, status_tmp, fsr_tmp
		
	endc

;**** Constantes *********
ce	equ	D'3'		; CE de ISD
religne	equ	D'0'		; Relais ligne
recom	equ	D'2'		; Relais commande
etat	equ	D'1'		; Etat systme
dv	equ	D'3'		; DV
son	equ	D'4'		; Sonnerie
bip	equ	B'00001000'	; Bip
actif	equ	B'00001001'	; Actif
arret	equ	B'00001010'	; Arrt
ok	equ	B'00001011'	; OK
non	equ	B'00001100'	; Non
menu	equ	B'00001111'	; Menu ISD
valsec	equ	D'244'		; 244 * 4.096 ms = 1000 ms


;***** Flag bit assignement *****
retour	equ	1

	org     4
	goto    Inter
;
	org     0
	goto    Start
;
	org     10
Start
	clrf	PORTA
	clrf	PORTB
	movlw	B'11110000'
	tris	PORTA
	bsf	PORTA,ce
	movlw   B'11111010'     
	tris 	PORTB
	movlw	B'00000011'	; pull-up RB (Entres en l'air = 1)
	option
	bsf	INTCON,5	; enable TMR0 interrupts
	clrf	flag

	movlw	1		; mot de passe (1313)
	movwf	n1
	movlw	3
	movwf	n2
	movlw	1
	movwf	n3
	movlw	3
	movwf	n4

	b	Main

;***************** Routine d'interruption (toutes les 4ms) *****************
	
Inter				; routine d'interruption

PUSH	
	bcf	INTCON,GIE
	movwf	w_tmp		; Sauvegarde FSR, STATUS et W
	swapf	STATUS,w
	movwf	status_tmp
	movf	FSR,W
	movwf	fsr_tmp
	
	decfsz	compt,F
	b	intc
	decf	duree,F		; dcrment toutes les sec.
	movlw	valsec
	movwf	compt
	
intc	clrf	INTCON
	bsf	INTCON,5
POP	
	movf	fsr_tmp,W
	movwf	FSR
	swapf	status_tmp,W	; Restauration FSR, STATUS et W
	movwf	STATUS
	swapf	w_tmp,F
	swapf	w_tmp,W

        retfie



;********** Delais **********************

Delay100			; delay 100s
	movlw	D'33'
	movwf	delay
l100	decfsz	delay,F
	b	l100
	return

Xdelay100			; delay W * 100
	movwf	xdelay
l500	call	Delay100
	decfsz	xdelay,F
	b	l500
retX	return

Sdelay				; delay W * 1"
	movwf	sdelay
loop5	call	Zdelay
	decfsz	sdelay,F
	b	loop5
	return

Zdelay
	movlw	D'40'		; pause 1"
Mdelay	movwf	zdelay		; delay W * 25ms
loop4	movlw	D'255'
	call	Xdelay100	; pause 25ms
	decfsz	zdelay,F
	b	loop4
	return

;************** Parler *********************************

Parler
	movwf	PORTA
	bcf	PORTA,ce	; enable
	bsf	PORTA,ce	; disable

	return

;************** Mdp *******************
; Mot de passe

Mdp
	movlw	3
	movwf	essai
dibip	movlw	bip
	call	Parler		; Bip
	bcf	INTCON,GIE	; disable interrups
	movlw	6
	movwf	duree
	movlw	valsec
	movwf	compt
	bsf	INTCON,GIE	; enable interrupts
	movlw	4
	movwf	count
	movwf	resu
	movlw	H'0C'
	movwf	FSR
rchi	call	Rchiffre	; rception chiffre
	movf	ret,F
	skpnz			; skip si ret <> 0
	b	decess
	movfw	ret
	subwf	INDF,W
	skpz			; skip si chiffre OK
	b	fsrp
	decf	resu,F
fsrp	incf	FSR,F
	decfsz	count,F
	b	rchi
	movlw	1
	call	Sdelay		; pause 1sec (combin vers oreille)
	movf	resu,F
	skpnz			; skip si resu<>0 (mauvais code)
	b	ret1
decess	decfsz	essai,F
	b	dibip
	bcf	flag,retour
	b	retmdp
ret1	bsf	flag,retour
	
retmdp	return

;************** Rchiffre ******************

Rchiffre
testdv	btfss	PORTB,dv	; skip si DV=1
	b	testdur
	movlw	B'00001111'
	movwf	var
	swapf	PORTB,W
	andwf	var,W
	movwf	ret
tstdv	btfsc	PORTB,dv	; skip si DV=0
	b	tstdv
	b	retrc
testdur	movf	duree,F
	skpz			; skip si duree=0
	b	testdv
	clrf	ret
	
	
retrc	return

;************** Menu *****************************

Menu
	
c3	movlw	8
	movwf	count		; environ 2x le menu avant de raccrocher
disi	decfsz	count,F
	b	cgie
	clrf	ret
	b	retmen
cgie	bcf	INTCON,GIE	; disable interrups
	movlw	2		; 2 sec de test touches
	movwf	duree
	movlw	valsec
	movwf	compt
	bsf	INTCON,GIE	; enable interrupts

	movlw	menu
	call	Parler
	call	Rchiffre
	movf	ret,F
	skpnz			; skip si touche
	b	disi
	movlw	3
	subwf	ret,W
	skpnc			; skip si choix < 3
	b	c3
	movlw	1
	call	Sdelay		; pause 1"


retmen	return

;************** Interro ******************
; Interrogation de l'tat du systme

Interro
	movlw	5
	movwf	count
tstetat	btfss	PORTB,etat
	b	warr
	movlw	actif
	b	cause
warr	movlw	arret
cause	call	Parler
	movlw	D'30'		; 750ms
	call	Mdelay
	decfsz	count,F
	b	tstetat
	return

;************** Modif ********************

Modif
	bsf	PORTB,recom
	movlw	1
	call	Sdelay
	bcf	PORTB,recom
	call	Interro
	return

;************** Sonnerie ************************

Sonnerie

movc	movlw	8
	movwf	count		; nbr de sonneries
enint	bcf	INTCON,GIE	; disable interrups
	movlw	5
	movwf	duree		; en sec
	movlw	valsec
	movwf	compt
	bsf	INTCON,GIE	; enable interrupts
tstson	btfss	PORTA,son	; test dbut de sonnerie
	b	tstdu
tstfson	btfsc	PORTA,son	; test fin de sonnerie
	b	tstfson
	decfsz	count,F
	b	enint
	b	retson
tstdu	movf	duree,F
	skpz
	b	tstson
	b	movc
	
retson	return

;************** Main **********************************

Main
	
srel	bsf	PORTB,religne	; desactive relais ligne
	call	Sonnerie	; boucle sur test sonnerie
	bcf	PORTB,religne	; dcroche
	call	Mdp		; teste mot de passe
	btfss	flag,retour	; skip si mdp OK
	b	srel
cmenu	call	Menu		; nonce le menu, et choix
	movf	ret,F
	skpnz			; skip si touche actionne
	b	srel
	movlw	1
	subwf	ret,W
	skpz			; skip si choix 1
	b	cmodif
	call	Interro		; interrogation de l'tat
	b	cmenu
cmodif	call	Modif		; modification de l'tat
	b	cmenu
	
	end
